Foreman - Bug #23291

Proxy template URL not used for kickstart
04/16/2018 02:21 PM - Adam Ruzicka

Status: Closed
Priority: High
Assignee: Arend Lapere
Category: Templates

Target version:

Difficulty: Fixed in Releases: 1.18.1, 1.19.0
Triaged: No Found in Releases: 1.18.0-RC1, 1.18.0-RC2, 1.18.0-RC3
Bugzilla link: 1624072 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/5822,
https://github.com/theforeman/foreman/p
ull/5852,
https://github.com/theforeman/foreman/p
ull/5853
Description

Steps to reproduce:

1) Have a smart-proxy with templates feature

2) Set template_url to use http in /etc/smart-proxy/settings.d/templates.yml
3) Assign the proxy to a subnet as template proxy

4) Try to provision a host in subnet from step 3

Actual result:
The host tries to access the proxy over the https and fails because CA used to signed the proxy's certificate is not trusted

Expected result:
template_url is honored and provisioning doesn't fail

After observing the log, we noticed that the base url is trying to access the templateServer API on the wrong URL:
https://&lt;proxy&gt;:8443/unattended*/unattended* while it should be https://&lt;proxy&gt;:8443/unattended

Related issues:
Has duplicate Foreman - Bug #24787: Templates subnet association renders to C... Duplicate

Associated revisions

Revision bfca460d - 07/18/2018 03:50 PM - Arend Lapere
fixes #23291 - fixes double appending of /unattended to proxy url

History

#1 - 07/09/2018 02:36 PM - Arend Lapere

- Triaged set to No

Hello,

Could it be that you are running into this on 1.18-RC1/2/3?

I've investigated a bit, and seems this patch-set is the culprit:
https://github.com/theforeman/foreman/commit/009e7bbd29{31c3750a8be4 7b4aecf5278c0db95#diff- 1b99c484fd9f41096d5029e5b20d6165

This creates the Template class twice (and appends the "/unattended" string to the URL):

- Once initiated when retrieving Subnet.template_proxy

- This template_proxy is than passed to the second instantiation, done in foreman_url_rendered, which is needed to retrieve actual templateServer
from the proxy.

To validate, I've removed the instance in app/models/subnet.rb:181 and simply returned the template variable, after this, all seems to behave as
expected.
https://&lt;proxy&gt;:8443/unattended*/unattended
https://&lt;proxy&gt;:8443/unattended
https://github.com/theforeman/foreman/commit/009e7bbd29f31c3750a8be47b4aecf5278c0db95#diff-1b99c484fd9f41096d5029e5b20d6165

Although the latter is probably not the answer, as it seems to be more in line with the rest of the modules (e.g. DNS, BMC, ...).

#2 - 07/09/2018 02:42 PM - Arend Lapere
- Found in Releases 1.18.0-RC1, 1.18.0-RC2, 1.18.0-RC3 added

#3 - 07/10/2018 07:17 AM - Arend Lapere
- Description updated
- Priority changed from Normal to High

#4 - 07/11/2018 12:35 PM - Arend Lapere

I've found a qualitative fix for this issue, I'm writing a test to make sure this one never comes back on our plate.

#5 - 07/11/2018 01:23 PM - Arend Lapere
- Assignee set to Aaron Stone

- Pull request https://github.com/theforeman/foreman/pull/5822 added

#6 - 07/11/2018 01:23 PM - Arend Lapere

- Assignee deleted (Aaron Stone)

#7 - 07/11/2018 01:29 PM - The Foreman Bot
- Status changed from New to Ready For Testing

#8 - 07/18/2018 04:01 PM - Anonymous
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset bfca460de52da0397d22fb1fddc795c2a4184e03.

#9 - 07/19/2018 06:51 AM - Marek Hulan
- Target version set to 1.20.0

- Fixed in Releases 1.20.0 added

#10 - 07/19/2018 07:06 AM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/5852 added

#11 - 07/19/2018 07:27 AM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/5853 added

#12 - 07/19/2018 07:29 AM - Arend Lapere
- Fixed in Releases 1.18.1, 1.19.0-RC1 added

#13 - 07/19/2018 07:51 AM - Tomer Brisker

- Assignee set to Arend Lapere

#14 - 07/23/2018 01:35 PM - Tomer Brisker
- Fixed in Releases 1.19.0 added
- Fixed in Releases deleted (1.19.0-RC1)

#15 - 07/24/2018 02:13 PM - Tomer Brisker

- Category set to Templates

#16 - 08/29/2018 03:38 PM - Greg Sutcliffe
- Fixed in Releases deleted (1.20.0)

#17 - 09/03/2018 02:04 PM - Lukas Zapletal
- Bugzilla link set to 1624072
https://projects.theforeman.org/projects/foreman/repository/foreman/revisions/bfca460de52da0397d22fb1fddc795c2a4184e03

#18 - 10/15/2018 09:15 AM - Tomer Brisker

- Has duplicate Bug #24787: Templates subnet association renders to Capsule URL and not template_url added

#19 - 10/23/2018 03:07 PM - Tomer Brisker
- Target version deleted (1.20.0)
